package ch.zhaw.ads;

import java.util.*;

@SuppressWarnings("unchecked")
public class MyHashtable<K, V> implements Map<K, V> {
    private K[] keys;// = (K[]) new Object[10];
    private V[] values;// = (V[]) new Object[10];

    private int hash(Object k) {
        int h = Math.abs(k.hashCode());
        return h % keys.length;
    }

    public MyHashtable(int size) {
        // to be done
        keys = (K[]) new Object[size];
        values = (V[]) new Object[size];
    }

    public MyHashtable() {
        clear();
    }

    // Removes all mappings from this map (optional operation).
    public void clear() {
        // to be done
        keys = (K[]) new Object[1000];
        values = (V[]) new Object[1000];
    }

    // Associates the specified value with the specified key in this map (optional operation).
    public V put(K key, V value) {
        // to be done
        if(size() >= keys.length) {
            throw new IllegalStateException("Overflow");
        } else {
            int i = -1;
            int hashCode = hash(key);
            int index;
            do {
                i++;
                index = (hashCode + i) % keys.length;
            } while (keys[index] != null && !keys[index].equals(key));
            keys[index] = key;
            values[index] = value;
        }
        return value;
    }

    // Returns the value to which this map maps the specified key.
    public V get(Object key) {
        // to be done
        int i = -1;
        int hashCode = hash(key);
        int index;
        do {
            i++;
            index = (hashCode + i) % keys.length;
        } while (keys[index] != null && !(keys[index].equals(key)));
        return values[index];
    }

    // Removes the mapping for this key from this map if present (optional operation).
    public V remove(Object key) {
        // to be done (Aufgabe 3)
        int i = -1;
        int hashCode = hash(key);
        int index;
        do {
            i++;
            if(i >= keys.length){
                return null;
            }
            index = (hashCode + i) % keys.length;
        } while (keys[index] != null && !(keys[index].equals(key)));
        V toReturn = values[index];
        keys[index] = null;
        values[index] = null;
        List<K> keysToRehash = new ArrayList<>();
        List<V> valuesToRehash = new ArrayList<>();
        i++;
        index = (hashCode + i) % keys.length;
        while(keys[index] != null) {
            keysToRehash.add(keys[index]);
            valuesToRehash.add(values[index]);
            keys[index] = null;
            values[index] = null;
            i++;
            index = (hashCode + i) % keys.length;
        }
        for(int indexToRehash = 0; indexToRehash < keysToRehash.size(); indexToRehash++){
            put(keysToRehash.get(indexToRehash), valuesToRehash.get(indexToRehash));
        }
        return toReturn;
    }

    // Returns the number of key-value mappings in this map.
    public int size() {
        // to be done
        int counter = 0;
        for(K key : keys) {
            if(key != null){
                counter++;
            }
        }
        return counter;
    }

    // UnsupportedOperationException ===================================================================
    // Returns a collection view of the values contained in this map.
    public Collection<V> values() {
        throw new UnsupportedOperationException();
    }

    // Returns true if this map contains a mapping for the specified key.
    public boolean containsKey(Object key) {
        throw new UnsupportedOperationException();
    }

    // Returns true if this map maps one or more keys to the specified value.
    public boolean containsValue(Object value) {
        throw new UnsupportedOperationException();
    }

    // Returns a set view of the mappings contained in this map.
    public Set<Map.Entry<K, V>> entrySet() {
        throw new UnsupportedOperationException();
    }

    // Compares the specified object with this map for equality.
    public boolean equals(Object o) {
        throw new UnsupportedOperationException();
    }

    // Copies all of the mappings from the specified map to this map (optional operation).
    public void putAll(Map<? extends K, ? extends V> t) {
        throw new UnsupportedOperationException();
    }

    // Returns the hash code value for this map.
    public int hashCode() {
        throw new UnsupportedOperationException();
    }

    // Returns true if this map contains no key-value mappings.
    public boolean isEmpty() {
        throw new UnsupportedOperationException();
    }

    // Returns a set view of the keys contained in this map.
    public Set<K> keySet() {
        throw new UnsupportedOperationException();
    }
}
